ENTRY(_start)
STARTUP(bin/arch/boot/boot.s.o)

SECTIONS
{
    . = 1M;

    .text BLOCK(4K) : ALIGN(4K){
        *(.multiboot)
        *(.text)
    }
    .rodata BLOCK(4K) : ALIGN(4K) {
        *(.rodata)
    }
    .data BLOCK(4K) : ALIGN(4K) {
        *(.data)
    }
    .bss BLOCK(4K) : ALIGN(4K) {
        *(COMMON)
        *(.bss)
    }
    .note.gnu.build-id BLOCK(4K) : ALIGN(4K) {
        *(.note.gnu.build-id)
    }

    end = .; _end = .; __end = .;

}
