#ifndef __IRQ_H__
#define __IRQ_H__

#include <isr.h>
#include <io.h>
#include <basic.h>

extern void irq0();
extern void irq1();
extern void irq2();
extern void irq3();
extern void irq4();
extern void irq5();
extern void irq6();
extern void irq7();
extern void irq8();
extern void irq9();
extern void irq10();
extern void irq11();
extern void irq12();
extern void irq13();
extern void irq14();
extern void irq15();

extern void *irq_routines[16];

int irq_install_handler(int irq, int (*handler)(struct regs *r));
int irq_uninstall_handler(int irq);
int irq_install();
#endif
